// Copyright (c) Microsoft Corporation. 
// Licensed under the MIT license. 

#include <string>
#include <stdlib.h>
#include <filesystem>
#include <future>
#include "SimplygonLoader.h"

class CustomObserver : public Simplygon::Observer
{
	public:
	Simplygon::ShadingColor OnShadingCustomNodeEvaluate(Simplygon::spObject subject) override
	{
		Simplygon::ShadingColor outputValue( 0.0f, 0.0f, 0.0f, 1.0f );
		if (!subject.IsNull())
		{
			Simplygon::spShadingCustomNode customNode = Simplygon::spShadingCustomNode::SafeCast(subject);
			if (!customNode.IsNull())
			{
				Simplygon::ShadingColor inputValue = customNode->GetInputValue(0);
				outputValue.r = inputValue.r * 0.393f + inputValue.g * 0.769f + inputValue.b * 0.189f;
				outputValue.g = inputValue.r * 0.349f + inputValue.g * 0.686f + inputValue.b * 0.168f;
				outputValue.b = inputValue.r * 0.272f + inputValue.g * 0.534f + inputValue.b * 0.131f;
			}
		}
		return outputValue;
	}
	bool OnShadingCustomNodeGenerateShaderCode(Simplygon::spObject subject, Simplygon::EShaderLanguage shaderLanguage) override
	{
		if (!subject.IsNull())
		{
			Simplygon::spShadingCustomNode customNode = Simplygon::spShadingCustomNode::SafeCast(subject);
			if (!customNode.IsNull())
			{
				customNode->SetCustomShaderCode( "result = float4(dot(rgba_custom_input_0, float3(0.393f, 0.769f, 0.189f)), dot(rgba_custom_input_0, float3(0.349f, 0.686f, 0.168f)), dot(rgba_custom_input_0, float3(0.272f, 0.534f, 0.131f)), 1.0f);");
				return true;
			}
		}
		return false;
	}
} customObserver;


void RunReductionWithShadingNetworks(Simplygon::ISimplygon* sg)
{
	Simplygon::spSceneImporter sgSceneImporter = sg->CreateSceneImporter();
	sgSceneImporter->SetImportFilePath( "../Assets/RiggedSimplygonMan/RiggedSimplygonMan.fbx" );
	if(!sgSceneImporter->RunImport())
		throw std::exception("Failed to load RiggedSimplygonMan/RiggedSimplygonMan.fbx.");
	Simplygon::spScene sgScene = sgSceneImporter->GetScene();

	Simplygon::spReductionProcessor sgReductionProcessor = sg->CreateReductionProcessor();

	sgReductionProcessor->SetScene( sgScene );

	Simplygon::spReductionSettings sgReductionSettings = sgReductionProcessor->GetReductionSettings();
	Simplygon::spMappingImageSettings sgMappingImageSettings = sgReductionProcessor->GetMappingImageSettings();

	// Generates a mapping image which is used after the reduction to cast new materials to the new 
	// reduced object. 
	sgMappingImageSettings->SetGenerateMappingImage( true );
	sgMappingImageSettings->SetApplyNewMaterialIds( true );
	sgMappingImageSettings->SetGenerateTangents( true );
	sgMappingImageSettings->SetUseFullRetexturing( true );

	// Inject a sepia filter as a custom shading node into the shading network for the diffuse channel 
	// for each material in the scene. 
	int materialCount = (int)sgScene->GetMaterialTable()->GetMaterialsCount();
	for (int i = 0; i < materialCount; ++i)
	{
		Simplygon::spMaterial sgMaterial = sgScene->GetMaterialTable()->GetMaterial(i);

		Simplygon::spShadingNode sgMaterialShadingNode = sgMaterial->GetShadingNetwork("Diffuse");
		Simplygon::spShadingCustomNode sgSepiaNode = sg->CreateShadingCustomNode();

		// Add the custom observer to our custom shading node.
		sgSepiaNode->AddObserver(&customObserver);
		
		// Set the number of input slots to the custom node. In this case we only use the diffuse color from the loaded material as input.
		sgSepiaNode->SetInputCount(1);


		sgSepiaNode->SetInput(0, sgMaterialShadingNode);

		sgMaterial->SetShadingNetwork("Diffuse", sgSepiaNode);

	}

	// Start the reduction process. 
	sgReductionProcessor->RunProcessing();

	// Setup and run the diffuse material casting. 
	Simplygon::spColorCaster sgDiffuseCaster = sg->CreateColorCaster();
	sgDiffuseCaster->SetMappingImage( sgReductionProcessor->GetMappingImage() );
	sgDiffuseCaster->SetSourceMaterials( sgScene->GetMaterialTable() );
	sgDiffuseCaster->SetSourceTextures( sgScene->GetTextureTable() );
	sgDiffuseCaster->SetOutputFilePath( "DiffuseTexture" );

	Simplygon::spColorCasterSettings sgDiffuseCasterSettings = sgDiffuseCaster->GetColorCasterSettings();
	sgDiffuseCasterSettings->SetMaterialChannel( "Diffuse" );
	sgDiffuseCasterSettings->SetOutputImageFileFormat( Simplygon::EImageOutputFormat::PNG );

	sgDiffuseCaster->RunProcessing();
	std::string diffuseTextureFilePath = sgDiffuseCaster->GetOutputFilePath();

	// Update scene with new casted texture. 
	Simplygon::spMaterialTable sgMaterialTable = sg->CreateMaterialTable();
	Simplygon::spTextureTable sgTextureTable = sg->CreateTextureTable();
	Simplygon::spMaterial sgMaterial = sg->CreateMaterial();
	Simplygon::spTexture sgDiffuseTexture = sg->CreateTexture();
	sgDiffuseTexture->SetName( "Diffuse" );
	sgDiffuseTexture->SetFilePath( diffuseTextureFilePath.c_str() );
	sgTextureTable->AddTexture( sgDiffuseTexture );

	Simplygon::spShadingTextureNode sgDiffuseTextureShadingNode = sg->CreateShadingTextureNode();
	sgDiffuseTextureShadingNode->SetTexCoordLevel( 0 );
	sgDiffuseTextureShadingNode->SetTextureName( "Diffuse" );

	sgMaterial->AddMaterialChannel( "Diffuse" );
	sgMaterial->SetShadingNetwork( "Diffuse", sgDiffuseTextureShadingNode );

	sgMaterialTable->AddMaterial( sgMaterial );

	sgScene->GetTextureTable()->Clear();
	sgScene->GetMaterialTable()->Clear();
	sgScene->GetTextureTable()->Copy(sgTextureTable);
	sgScene->GetMaterialTable()->Copy(sgMaterialTable);

	Simplygon::spSceneExporter  sgSceneExporter = sg->CreateSceneExporter();
	sgSceneExporter->SetScene(sgScene);
	sgSceneExporter->SetExportFilePath( "ReductionOutput.fbx" );
	if(!sgSceneExporter->RunExport())
		throw std::exception("Failed to save ReductionOutput.fbx.");

}

void main()
{
	Simplygon::ISimplygon* sg = NULL;
	Simplygon::EErrorCodes initval = Simplygon::Initialize( &sg );
	if( initval != Simplygon::EErrorCodes::NoError )
	{
		return;
	}

	RunReductionWithShadingNetworks(sg);

	Simplygon::Deinitialize(sg);
}

